unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Clipbrd, ExtCtrls;

const crlf = #13 + #10;
const sp = '    ';

type
  TForm2 = class(TForm)
    cmdopen: TButton;
    Label1: TLabel;
    txtSrcFile: TEdit;
    cmdUnPack: TButton;
    chkClipabord: TCheckBox;
    cmdAbout: TButton;
    cmdExit: TButton;
    CheckBox1: TCheckBox;
    chkIndent: TCheckBox;
    shpHeader: TShape;
    lblOptions: TLabel;
    Line3d1: TBevel;
    Shape1: TShape;
    procedure cmdUnPackClick(Sender: TObject);
    procedure cmdopenClick(Sender: TObject);
    procedure cmdExitClick(Sender: TObject);
    procedure cmdAboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

function GetRightStr(src: string; index: Integer): string;
begin
//hello
  GetRightStr := Copy(src, Length(src) - index + 1, index);
end;

procedure TForm2.cmdAboutClick(Sender: TObject);
begin
  MessageDlg(Caption + ' v1.0' + crlf + 'Benjamin George', mtInformation, [mbOK], 0);
end;

procedure TForm2.cmdExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm2.cmdopenClick(Sender: TObject);
var
  dlg: TOpenDialog;
begin
  //Create object.
  dlg := TOpenDialog.Create(self);
  dlg.Title := 'Select';
  dlg.Filter := 'Cascading Style Sheets(*.css)|*.css';
  if dlg.Execute then
  begin
    //Set text box with filename.
    txtsrcfile.Text := dlg.FileName;
  end;
  dlg.CleanupInstance;
  dlg.Free;
end;

procedure TForm2.cmdUnPackClick(Sender: TObject);
var
  lzfile: string;
  sl: TStringList;
  I: Integer;
  sPos: Integer;
  Buffer: string;
  StrTemp: string;
  StrLine: string;
  tf: TextFile;
begin

  //Get filename.
  lzfile := Trim(txtSrcFile.Text);

  //Check for filename.
  if Length(lzfile) = 0 then
  begin
    MessageDlg('A valid input filename is required.', mtWarning, [mbOK], 0);
    cmdopen.SetFocus;
    Exit;
  end;

  //Check if filename has been removed.
  if not FileExists(lzfile) then
  begin
    MessageDlg('Input filename was not found, or the file may have been moved:' + crlf + lzfile, mtWarning, [mbOK], 0);
    cmdopen.SetFocus;
    Exit;
  end;

  //Check if we need to make a backup of original file.
  if chkClipabord.Checked then
  begin
    copyfile(PChar(lzfile), PChar(lzfile + '.bak'), True);
  end;

  //Create string list.
  sl := TStringList.Create;
  //Load source file.
  sl.LoadFromFile(lzfile);

  //Set buffer to stringlist text.
  Buffer := sl.Text;
  //Clear the stringlist.
  sl.Clear;

  //Clean up the compressed css file.
  Buffer := StringReplace(Buffer, '{', ' {' + crlf, [rfReplaceAll, rfIgnoreCase]);
  Buffer := StringReplace(Buffer, ',', ', ', [rfReplaceAll, rfIgnoreCase]);
  Buffer := StringReplace(Buffer, '}', crlf + '}' + crlf, [rfReplaceAll, rfIgnoreCase]);
  Buffer := StringReplace(Buffer, ';', ';' + crlf, [rfReplaceAll, rfIgnoreCase]);

  //Extract the string into the string list.
  ExtractStrings([#13, #10], [], PChar(Buffer), sl);
  //Clear buffer.
  Buffer := '';

  //indent css propertie names add space between property and value.
  for I := 0 to sl.Count - 1 do
  begin
      //Get line
    StrLine := Trim(sl[I]);
      //Check for : in string.
    sPos := Pos(':', StrLine);
    if sPos > 0 then
    begin
      //Check for end of line marker.
      if GetRightStr(StrLine, 1) <> ';' then
      begin
        //Add end marker.
        StrLine := StrLine + ';';
      end;
      //Check for : in string.
      sPos := Pos(':', StrLine);

      //Check for : position.
      if sPos > 0 then
      begin
        //Split the line in half.
        StrTemp := Trim(Copy(StrLine, sPos + 1));
        StrLine := Trim(Copy(StrLine, 1, sPos));
        //Remake the line with the space included.
        StrLine := StrLine + ' ' + StrTemp;
      end;

      //Check if indenting lines.
      if chkIndent.Checked then
      begin
      //Indent the line.
        StrLine := sp + StrLine;
      end;
    end;

    //Just add an extra line break make css more readable.
    if StrLine = '}' then
    begin
      //Append crlf to strline.
      StrLine := StrLine + crlf;
    end;
   //Build the output string.
    Buffer := Buffer + StrLine + crlf;
  end;

  //Save new file.
  try
    //Assign file.
    assignfile(tf, lzfile);
    Rewrite(tf);
    //Write buffer to file.
    Write(tf, Buffer);
    //Close file.
    CloseFile(tf);
    MessageDlg('File was successfully unpacked' + crlf + lzfile, mtInformation, [mbOK], 0);
    //Finish message.
  except
    MessageDlg('There was an error while writing to the input filename.' + crlf + lzfile, mtWarning, [mbOK], 0);
  end;

  //Check if need copying to clipboard.
  if chkClipabord.Checked then
  begin
    //Copy css to clipboard.
    clipboard.SetTextBuf(PChar(Buffer));
  end;

  StrLine := '';
  StrTemp := '';
  Buffer := '';
  sl.CleanupInstance;
  sl.Free;
end;

end.

